// pen holder for plotting robot

$fn = 64;

// holder variables
penDiameter = 14.8; // 12.5mm works with Sharpie Fine
                  // 11.75 for Visa-vis
                  // 10 mm for Crayola Washables
penRadius = penDiameter / 2;
barrelHieght = 12;
barrelWallThickness = 3;
baseThickness = 3;
cornerRounding = 2;

hat_thickness = 1.6;

hatDiameter = 29;
slice = 1.6;


module penHolder(){

	difference(){
		//// lip
        cylinder(hat_thickness, hatDiameter / 2, hatDiameter / 2);
        
        // pen hole
 translate(v = [0,0,0]){       
     translate(v = [0,0,-1]){   cylinder(baseThickness, penRadius, penRadius);
     }
 }      

        // expansion slice
        translate([ -slice / 2, 0, -1])
        cube([  slice, hatDiameter, barrelHieght+2]);
    translate([ -slice / 2, -39, -1])
        cube([  slice, hatDiameter, barrelHieght+2]);      
	}

	// pen barrel
	difference(){
        // barrel

        barrel();

		// bore
     translate(v = [0,0,-1]){   
		cylinder(   barrelHieght * 2, penRadius, penRadius);
     }
        
        // expansion slice
        translate([ -slice / 2, 0, 0])
        cube([  slice, hatDiameter * 2, hatDiameter * 2]);   
	};  
}

module barrel()
        union(){{
		cylinder(	barrelHieght, 
					penRadius + hat_thickness, 
					penRadius + hat_thickness);


        rotate_extrude($fn=200)
        //rotate([90, 0, 0])
        translate([-penRadius - 2 * hat_thickness, hat_thickness, 0])
        polygon(points=[[2,2], [2,0], [0,0]]);
        }
    }
//barrel();
penHolder();





